# Yeelight.js [![Build Status](https://travis-ci.org/kbariotis/yeelight.js.svg?branch=master)](https://travis-ci.org/kbariotis/yeelight.js)
Control all of your Yeelight Devices with Node.js

[Yeelight products](https://www.yeelight.com/)

Big thanks to [Travelport-Ukraine/npm-module-boilerplate](https://github.com/Travelport-Ukraine/npm-module-boilerplate) 
for their great boilerplate.

You can find the API documentation of the Yeelight devices 
[here](http://www.yeelight.com/download/Yeelight_Inter-Operation_Spec.pdf).

## Docs

* Read the generated documentation [here](https://github.com/kbariotis/yeelight.js/blob/master/DOCS.md).
* Check the examples in [`examples/` folder](https://github.com/kbariotis/yeelight.js/blob/master/examples/).

## Contributing

[Read this first](https://github.com/kbariotis/yeelight.js/blob/master/CONTRIBUTING.md)

This module uses Babel to transpile Stage 2 Javascript and airbnb's style.

- `npm run clean` - Remove `lib/` directory
- `npm test` - Run tests.
- `npm test:watch` - You can even re-run tests on file changes!
- `npm run cover` - Yes. You can even cover ES6 code.
- `npm run lint` - Lint your code.
- `npm run flow` - Check using Flow.
- `npm run test:examples` - Write your examples on pure JS for better understanding module usage.
- `npm run build` - Build.
- `npm run build-docs` - Build documentation using Documentation.
- `npm run prepublish` - Hook for npm. Do all the checks before publishing you module.

## License
[MIT Licence](https://github.com/kbariotis/yeelight.js/blob/master/LICENCE)
